/*
 * $Id: State.h,v 1.1 2001/09/18 20:41:49 andbo928 Exp $
 * 
 * HISTORY 
 *
 * $Log: State.h,v $
 * Revision 1.1  2001/09/18 20:41:49  andbo928
 * Imported some sources from FuzzyFoo.
 *
 * Revision 1.4  2001/06/05 20:33:53  mikbr212
 * Fixed doxygen-stubs for all classes
 *
 */

/**
 * @file State.h
 * Definition file for the class State.
 *
 * @par Unit:
 *      Framework/view
 * $Revision: 1.1 $
 * $Author: andbo928 $
 * $Date: 2001/09/18 20:41:49 $
 */

#ifndef STATE_H
#define STATE_H

#include "machine_dependent_compiler_directives.h"
#include <iostream.h>
#include <string.h>

RS_BEGIN_NAMESPACE

template<class T> 
std::string asString(const T& data)
{
  return std::string((char*) &data, sizeof(T));
}

template<class T>
T fromString(T, const std::string& str)
{
  T d;
  memcpy(&d, str.data(), sizeof(T));
  return d;
}

template<class T>
std::string skipString(T, const std::string& str)
{
  return str.substr(sizeof(T));
}

/**
 * @class State State.h
 * Text...
 */

class State
{
public:
  // Nested types.
  
private:
  // Private methods/attributes.
  
protected:
  // Protected methods/attributes.
  

public:
  // Virtual destructor
  virtual ~State();
  // Public methods/attributes.
  virtual void step() = 0;
  // Returns number of chars needed.
  virtual std::string serialize() const = 0;
  // Returns number of chars consumed.
  virtual std::string deserialize(const std::string& buf) = 0;
};

RS_END_NAMESPACE
#endif /* WORLDSTATE_H */
